﻿namespace HeuristicLab.Problems.ProgramSynthesis {

  using HeuristicLab.Common;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class StringErcOptions : ErcOption<string> {
    public StringErcOptions() { }
    public StringErcOptions(params WeightedErcItem<string>[] values) : base(true, values) { }
    public StringErcOptions(bool isEnabled, params WeightedErcItem<string>[] values) : base(isEnabled, values) { }

    [StorableConstructor]
    public StringErcOptions(bool deserializing) : base(deserializing) { }

    public StringErcOptions(StringErcOptions origin, Cloner cloner) : base(origin, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new StringErcOptions(this, cloner);
    }

    public override string ToString() {
      return "String";
    }
  }
}
